#include "RROScommands.bas"
// above file must be in the same directory as this program
// (or include path with file name)
// Note: you may comment out if you do not have the file
// and you are using only the simulation.

main:
  Real=true  // change to True for REAL robot
  DoorNum = 2 // which door to go through
  gosub InitRROScommands
  if not Real then gosub DrawWalls
  gosub Initialization
  for i=1 to DoorNum
    call ForwardTill(NoDoor,DoorWidth)
    delay 100
    call ForwardTill(Door,DoorWidth)
    delay 100
  next
  // backup to center of doorway
  if Real
    rForward -18*DoorWidth/2 +16
  else
    rForward -DoorWidth/2+16
  endif
  gosub ThroughDoor
end

// the following routine only used for initial test
// then replaced with ForwardTill( )
MoveDownHallway:
  DistRight = rRange(90)
  for i=1 to 400
    rForward 1
    if rRange(90)>DistRight
      rTurn 1
    else
      rTurn -1
    endif
  next
return

DrawWalls:
  LineWidth 10   
  Line 300,20,300,85
  Line 300,150,300,220   // door width 65
  Line 300,330,300,420   // door width 110
  Line 300,510,300,580   // door width 90
  Line 420,20,420,580
return

Initialization:
  //Initialize the real or simulated robot
  if not Real
    rLocate 340+Random(30),550
  else
    gosub InitRB9robot
  endif
  DistRight=rRange(90)
  DistLeft=rRange(-90)
  Door = 1
  NoDoor = 2
  rSlip 10
  rInvisible Green
  rPen Down
  LineWidth 5
return

sub ForwardTill(condition,&dist)
  dist=0
  while 1
    rForward 1
    if rRange(90)>_DistRight
      rTurn 1
    else
      rTurn -1
    endif
    LeftDist=rRange(-90)
    if (condition = _NoDoor) && (LeftDist>(_DistLeft+20)) then break
    if (condition = _Door) && (LeftDist<(_DistLeft+20)) then break
    dist++
  wend
  rForward 3
return
 
ThroughDoor:
  rTurn -90
  for j=1 to 100
    rForward 1 
    if rFeel()&2 then rTurn -5
    if rFeel()&8 then rTurn 5
  next   
return

InitRB9robot:
  rCommport 3 // comm port for Bluetooth adapter
  rlocate 0,0
  rCommand(MotorSetup,SMALLDC+ENCODERS)  //+HMC6352 if you have a compass
  rCommand (SensorSetup,SR04+FIVERANGE) // RB-9
  rCommand(SetMotorRamp,5)
  rCommand(SetClicksPerDiam,160)
  rCommand(SetClicksPer90,110) 
  rCommand(SetReducForwRight,0)
  rCommand(SetReducForwLeft,15)
  rCommand(SetReducBackRight,0)
  rCommand(SetReducBackLeft,0)
  rCommand(SetRotationTime,18) // 19)
  rCommand(SetMoveTime,12) //13) 
  rCommand(SetSpeed,45) //65) //,35)
  rCommand(SetSlowDownSpeed,35) //45) 
  rCommand(SetSlowDown2,25) 
  rCommand(SetCCdivisor,3)
  rCommand(SetBumpDist,10)
  rCommand(SetProxDist,15)
  rCommand(EnableCounters,1)
  // allow slow turns
  rCommand(SetTurnStyle,60)
  rCommand(SetRROStimeout,15)
return
    


